<?php

/**
 * Created by xDeveloper.
 * Site: http://www.xf-ar.com
 * Email: turkialawlqy@gmail.com
 * Date: 5/16/16,  11:15 AM
 */
class Turki_Ranks_ControllerAdmin_UserRanks extends XenForo_ControllerAdmin_Abstract
{
    protected function _preDispatch($action)
    {
        $this->assertAdminPermission('user');
    }

    public function actionIndex()
    {
        $optionModel = XenForo_Model::create('XenForo_Model_Option');
        $options = $optionModel->getOptionsByIds(array('userRankField'));

        $viewParams = array(
            'titles' => $this->_getLadderModel()->getAll(),
            'options' => $optionModel->prepareOptions($options),
            'canEditOptionDefinition' => $optionModel->canEditOptionAndGroupDefinitions()
        );

        return $this->responseView('XenForo_ViewAdmin_UserTitleLadder_List', 'user_ranks_list', $viewParams);
    }

    public function actionUpdate()
    {
        $this->_assertPostOnly();

        $update = $this->_input->filterSingle('update', XenForo_Input::ARRAY_SIMPLE);
        $delete = $this->_input->filterSingle('delete', array(XenForo_Input::UINT, 'array' => true));
        foreach ($delete AS $deletePoint)
        {
            unset($update[$deletePoint]);
        }

        $input = $this->_input->filter(array(
            'rank_minimum_level' => XenForo_Input::UINT,
            'rank' => XenForo_Input::STRING,
            'rank_type' => XenForo_Input::STRING,
            'ranklevel' => XenForo_Input::UINT,
        ));
        $trophyModel = $this->_getLadderModel();

        XenForo_Db::beginTransaction();

        $trophyModel->deleteUserRankEntries($delete, false);
        $trophyModel->updateUserRanks($update, false);

        if ($input['rank'])
        {
            $trophyModel->insertUserRanksEntry($input, false);
        }

        $trophyModel->rebuildUserRanksCache();

        XenForo_Db::commit();

        return $this->responseRedirect(
            XenForo_ControllerResponse_Redirect::SUCCESS,
            XenForo_Link::buildAdminLink('user-ranks')
        );
    }

    /**
     * @return Turki_Ranks_Model_Ranks
     */
    protected function _getLadderModel()
    {
        return $this->getModelFromCache('Turki_Ranks_Model_Ranks');
    }
}